/* Easi System - 

  Copyright (C) 2001, 2002 David Lewin, Patrick Toutati

  Easi System is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published
  by the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */



#include <stddef.h>
#include <stdio.h>
#include <ctype.h>               // toascii
#include <sys/types.h>
#include <sys/statfs.h>           //Pour statfs (free_space)
#include <dirent.h>
#include <unistd.h>               // Pour unlink 
#include <asm/io.h>               // Pour outb, inb
#include <ncurses.h>
#include <stdlib.h>

#include <string.h>

// Test pour gdsl

#include "gdsl.h"
#include "_integers.h"

#ifdef HAVE_MEM_DEBUG
#include "_gdsl_mem.h"
#endif

static void affiche_liste_chaines_fwd (gdsl_list_t l);
static void affiche_liste_chaines_bwd (gdsl_list_t l);
static int affiche_chaine (gdsl_element_t chaine, void *user_infos);
static void affiche_element (gdsl_element_t chaine, FILE *file, void *user_data);
static gdsl_element_t alloue_chaine (void *chaine);
static void detruis_chaine (gdsl_element_t chaine);
static int compare_chaines (gdsl_element_t chaine, void *value);

// Fin de GDSL ------------------------------------------------------------

#define USER_BLOCKS(s) (s.f_blocks - (s.f_bfree - s.f_bavail))
#define PERCENT_USED(s) (100 * ((float)(USER_BLOCKS(s) - s.f_bavail) / \
           (float)USER_BLOCKS(s)) )

#define WIDTH  30
#define HEIGHT 10

#define REPERTOIRE_ENTIER 10
#define UN_SEUL_FICHIER   20

#define CHEMIN_ORIGINE_MUSIQUES "/home/workspace/tests/orig/musiques/"
#define CHEMIN_ORIGINE_MESSAGES "/home/workspace/tests/orig/messages/"

#define CHEMIN_DESTINATION_MUSIQUES "/home/workspace/tests/dest/musiques/"
#define CHEMIN_DESTINATION_MESSAGES "/home/workspace/tests/dest/messages/"

#define lpt_port  0x378	         // Changer l'adresse du port ici
#define STATUS    lpt_port+1
#define CONTROL   lpt_port+2

/* Une srie de dfinitions pour simplifier la programmation */
#define SET_E outb(inb(CONTROL) & 0xFE,CONTROL) /* E=1 (Strobe) */
#define RAZ_E outb(inb(CONTROL) | 0x01,CONTROL) /* E=0 (Strobe) */
#define SET_RS outb(inb(CONTROL) & 0xF7,CONTROL) // RS=1, donne : caractre
#define RAZ_RS outb(inb(CONTROL) | 0x08,CONTROL) // RS=0, donne : instruction

#define HAUT          TRUE 
#define BAS           FALSE

#define AFFICHE_STATS 1
#define ESPACE_LIBRE  2
#define COPIER_FICH   3
#define COPIER_REP    4
#define SUPPRIMER_REP 5
#define TESTS         6

#define MUSIQUE       1
#define MESSAGE       2

#define LETTRE_A      97
#define LETTRE_Z      122
#define LETTRE_E      101 

int startx = 0, starty = 0    ; 
unsigned int menu_index       ;
int LCD_lines[4]={0x00,0x40,0x14,0x54};
char *choices[]={"Stats Generales","espace Occupe","Copier 1 fichier","copier Repertoire","Suppr. Rep. /Musiq","","Quitter"};
int n_choices ;

void print_menu(WINDOW *menu_win,int highlight) ;
int Copie(char * source, int type_dest)         ;
int Copie_CD_HD(int type_dest) ;
//unsigned int check_dir(char *chemin, bool Affiche)       ;
float Get_Disk_Stats(char * chemin)             ;
int del_dir(char *repertoire)                   ;
void Tempo(unsigned long temps)                 ;
char *intoa(int i)                              ;

void Init_LCD (void)                            ;
void Efface_LCD (void)                          ;
void Ecrire_LCD (char *Chaine, char Position)   ;
void Menu_LCD(int index_menu)                   ;

void Clean_Lines();
int Check_Dir2(char *chemin);

void Scroll2(bool Haut, int index_courant2,gdsl_list_t liste);

void initialise_affichage(gdsl_list_t la_liste);
void  remplit_liste(gdsl_list_t liste_in, char *path);
bool fichier_existe(char *nom_fichier);

unsigned int Lit_Clavier();
// Tableaux de travail pour les lignes LCd

char Ligne1[21]="",Ligne2[21]="",Ligne3[21]="",Ligne4[21]=""      ;

static char buf[12]                                               ; // Intoa

gdsl_element_t e;
gdsl_perm_t alpha ;


//------------------------- DEBUT DU MAIN -------------------------------

int main(void)
{
 WINDOW *menu_win                         ;
 int highlight = 1,choice =0,c, char_lu   ;
 int ret=0,nb_fich,menu_max,max_menu_fich ;
 float espace_occupe                      ;
 char *buffer="", *nom_fichier="";
 gdsl_list_t liste_menu,liste_messages_HD, liste_musiques_HD ;
 gdsl_list_t liste_actuelle,liste_messages_CD, liste_musiques_CD     ;

 int i, Nb_Fichiers,  index_actu=1 ;
 unsigned long  index_menu_fich ;
 char buf[100], buf2[100];
 ulong pos;
 struct dirent **namelist;
 int n, result, sous_menu =0 ;
 bool scroll_existe = FALSE  ;

 liste_musiques_CD = gdsl_list_create("Musiques CD",alloue_chaine,detruis_chaine);    
 liste_messages_CD = gdsl_list_create("Messages CD",alloue_chaine,detruis_chaine);
 liste_musiques_HD = gdsl_list_create("Musiques HD",alloue_chaine,detruis_chaine);    
 liste_messages_HD = gdsl_list_create("Messages HD",alloue_chaine,detruis_chaine);


 liste_menu = gdsl_list_create("Liste Menu",alloue_chaine,detruis_chaine);    

 
 remplit_liste(liste_musiques_CD, CHEMIN_ORIGINE_MUSIQUES);   
 remplit_liste(liste_messages_CD, CHEMIN_ORIGINE_MESSAGES);

           // Creation du menu
 gdsl_list_insert_head(liste_menu,"Quitter");
 gdsl_list_insert_head(liste_menu,"");
 gdsl_list_insert_head(liste_menu,"Suppr. Rep. /Musiq");
 gdsl_list_insert_head(liste_menu,"copier Repertoire");
 gdsl_list_insert_head(liste_menu,"Copier 1 fichier");
 gdsl_list_insert_head(liste_menu,"espace Occupe");
 gdsl_list_insert_head(liste_menu,"Stats Generales");

 liste_actuelle = liste_musiques_CD ; // valeur par dfaut

 menu_max = gdsl_list_get_card (liste_menu) ;
 n_choices =  menu_max ; // a retirer

 if(ioperm(lpt_port,3,1))   // Demande d'acces au port parallele
 {
   perror("Erreur ioperm: ");
   exit(1);
 }

 Init_LCD()                    ; 
 initscr()                     ;
 clear()                       ;
 noecho()                      ;
 cbreak()                      ;
 
 startx = (80 - WIDTH)/2       ;
 starty = (24 - HEIGHT)/2      ;
 
 menu_win = newwin(HEIGHT,WIDTH,starty,startx)             ;
 keypad(menu_win,TRUE)                                     ;
 
 print_menu(menu_win,highlight)                            ;
 initialise_affichage(liste_menu);
 index_menu_fich = 1 ;

 while(1) 
 { 
  menu_index =  1              ;
  choice = 0                   ;
  max_menu_fich = gdsl_list_get_card (liste_actuelle) ; // mettre  jour
  c = wgetch(menu_win)         ;
 
  switch(c)
  {  

  case KEY_LEFT : sous_menu = 0;   // Sortir du sous-menu
                  initialise_affichage(liste_menu);
		  highlight = 1 ;
		  break ;

  case 10  : 
    if (sous_menu)  //est on actuellement dans un sous-menu ?
    {
      //action lie dans le sous-menu en actuel
      // Un choix a ete fait : faire l'action demandee



    if(sous_menu == COPIER_FICH)
    { 
      nom_fichier  = (char*) gdsl_list_search_by_position (liste_actuelle, index_menu_fich);
      if (liste_actuelle == liste_musiques_CD)
	strcpy(buf2,CHEMIN_DESTINATION_MUSIQUES);
      if (liste_actuelle == liste_messages_CD)
	strcpy(buf2,CHEMIN_DESTINATION_MESSAGES);
      strcat(buf2,nom_fichier);

      //Ajouter verfifications : copie ok, fichier deja present...

      // TEST fichier deja existant copie
      
     if( fichier_existe(buf2))
     {
       mvprintw(22,0,"Fichier existe, Remplacer ? (A=OK)");
       Efface_LCD();       
       Ecrire_LCD(nom_fichier,0x00);
       Ecrire_LCD("Existe Remplacer ?",0x40);
       Ecrire_LCD("A: OK / Z: Annuler",0x14);
       
       if (Lit_Clavier() == LETTRE_A)
	 Copie(nom_fichier,MUSIQUE);

ET  Copie(nom_fichier,MESSAGE);
     }
     else 
     {
       Copie(nom_fichier,MUSIQUE);      
ET  Copie(nom_fichier,MESSAGE);
       mvprintw(22,0,"%s existe pas",nom_fichier);
       refresh();
     }     
     
     
     
    }
    
    if(sous_menu== AFFICHE_STATS )
      {
	scroll_existe = FALSE  ;
      }

     if(sous_menu== ESPACE_LIBRE )
     {
      espace_occupe = Get_Disk_Stats("/home/workspace/tests/orig/musiques/.");
      mvprintw(22,0,"%.1f occups",espace_occupe);
      refresh();
      gcvt(espace_occupe,3,buffer);
      Ecrire_LCD(buffer,0x41);
      Ecrire_LCD("% occupes",0x48);
      scroll_existe = FALSE  ;
     }

     if(sous_menu== COPIER_REP)
     {
      ret = Copie_CD_HD(MUSIQUE)  ;
      mvprintw(0,0,"Copi %d fichiers dans dest/musiques                ",ret);
      clrtoeol() ;
      refresh();
      scroll_existe = FALSE  ;
     }

     if(sous_menu== SUPPRIMER_REP)
     {
       ret = del_dir(CHEMIN_DESTINATION_MUSIQUES);
       mvprintw(0,0,"Supprim %d fichiers dans dest/musiques",ret);
       clrtoeol() ;
       refresh()  ;
       scroll_existe = FALSE  ;
     }

     if(sous_menu== TESTS)
     {

     }

     // On a fini de traiter la demande on retourne dans le menu principal
     initialise_affichage(liste_menu);
     highlight = 1 ;	
     sous_menu = 0;   // Sortir du sous-menu
     index_menu_fich = 1;
    }
    else  choice = highlight;
    sous_menu = choice ;
    scroll_existe = FALSE  ;
    break ;

   case KEY_UP :
  
		  if (sous_menu)
		  {
		    if( index_menu_fich==1)
		     index_menu_fich = max_menu_fich ;
		   else --index_menu_fich ;
		    if(scroll_existe)
		      Scroll2(BAS,index_menu_fich, liste_actuelle);
		   }
		  else
		   {
		    if(highlight ==1)
		      highlight = n_choices;
		    else --highlight;
		    Scroll2(BAS,highlight, liste_menu);
		   }
		 break ;

  case KEY_DOWN :  
                           // On est entre dans l'option
                   if (sous_menu) 
		   {
		     if (index_menu_fich == max_menu_fich)
		       index_menu_fich = 1;
		     else ++index_menu_fich ;
		     if(scroll_existe)
		       Scroll2(HAUT,index_menu_fich, liste_actuelle);
		   }
		   else 
		   {
		    if (highlight == n_choices)
		      highlight = 1;
		    else ++highlight;
		    Scroll2(HAUT,highlight, liste_menu);	 
		   }
		   break ;

  default : mvprintw(24,0,"Entr :%3d ",c);
               refresh();
	       break;
  } // switch
    

  print_menu(menu_win,highlight);

  // Preparation de chaque fonction AVANT l'appel de la commande demandee


  // Afficher toutes les stats : fichiers + disk space
  if (choice == AFFICHE_STATS) 
    {
      Efface_LCD();
      ret =Check_Dir2(CHEMIN_DESTINATION_MUSIQUES);
      buffer = intoa(ret);      
      Ecrire_LCD(buffer,0x00);
      Ecrire_LCD("fichiers musiques",0x03);
      
      ret = Check_Dir2(CHEMIN_DESTINATION_MESSAGES);
      buffer = intoa(ret);
      Ecrire_LCD(buffer,0x40);
      Ecrire_LCD("fichiers messages",0x43);
      refresh();
  }
	         // Verification de l'espace libre A FINIR !!
  if (choice == ESPACE_LIBRE)
  {

  }
	         // Copier un fichier
  if (choice == COPIER_FICH)
  {
    //Demander copier message ou musique ?
   Efface_LCD();       
   Ecrire_LCD("Choisir Copier ",0x00);
   Ecrire_LCD("A : Musiques ",0x40);
pas pris en compte --->   Ecrire_LCD("E : Messages ",0x14);
   Ecrire_LCD("Z: Annuler(a finir)",0x54);
       
   if (Lit_Clavier() == LETTRE_A)
       liste_actuelle = liste_musiques_CD ; // on veut scroller liste_musiques
   else if(Lit_Clavier() == LETTRE_E)
       liste_actuelle = liste_messages_CD ; // on veut scroller liste_musiques
   initialise_affichage(liste_actuelle);
   scroll_existe = TRUE ;  // on aura besoin de scroller la liste ensuite
  }
  
  if (choice == COPIER_REP)	         // Copier un Repertoire
  {

  }

  if (choice == SUPPRIMER_REP)
  {

  }
    
  if (choice == TESTS)
  {
   
/*  TEST DE menu scroll des fichiers en cours  
   
    alpha = gdsl_perm_create ("ALPHA", result, NULL, NULL, NULL, NULL);
    gdsl_perm_randomize (alpha);

  for (i = 0; i < result ; i++)
    {
      pos = gdsl_perm_get (alpha, i) ;
      // mvprintw (0,i,"%ld : ", pos);

      e = gdsl_list_search_by_position (liste_musiques, pos);
      if (e != NULL)
	mvprintw(10+i,0,"%s /pos :%d ", (char*)e,pos);
      refresh();
    }
  gdsl_perm_destroy (alpha);
*/
  }

  if (choice == menu_max )     // On sort
    break;

 } // while


 gdsl_list_destroy(liste_messages_CD);
 gdsl_list_destroy(liste_musiques_CD);
 gdsl_list_destroy(liste_messages_HD);
 gdsl_list_destroy(liste_musiques_HD);

 gdsl_list_destroy(liste_menu);


 clrtoeol();
 refresh();
 endwin();
 
 return 0;
}

// OK : lettre pour valider, NOK : annuler

unsigned int Lit_Clavier()
{
  cbreak();
  return(getch() ); 

  /*  switch(tst)
   {
   case LETTRE_A :   return(
     break ;
   case LETTRE_Z :   mvprintw(23,0,"LETTRE Z");
     break ;
   case LETTRE_E :   mvprintw(23,0,"LETTRE E");
     break ;
   default :    mvprintw(23,0,"Default");
   }
   refresh();*/

}

bool fichier_existe(char *nom_fichier)
{
  FILE *in_file;

  if ((in_file = fopen(nom_fichier,"r"))==NULL)
    return(FALSE);              //Fichier n'existe pas
  else return(TRUE)   ;         //Fichier existe deja

  fclose(in_file)   ;
}


void remplit_liste(gdsl_list_t liste_in, char *path)
{
  struct dirent **namelist;
  int n,result;

 // Remplir liste avec repertoire des musiques
 n = scandir(path,&namelist,0,alphasort);
 result = n  ; 

 if(n<0)
   perror("scandir");
 else
   while(n-- > 2)           // Sans . et ..
     gdsl_list_insert_head( liste_in, namelist[n]->d_name);

}



void initialise_affichage(gdsl_list_t la_liste)
{
  Efface_LCD();

  strcpy(Ligne1, (char*) gdsl_list_search_by_position (la_liste, 1) );
  strcpy(Ligne2, (char*) gdsl_list_search_by_position (la_liste, 2) );
  strcpy(Ligne3, (char*) gdsl_list_search_by_position (la_liste, 3) );
  strcpy(Ligne4, (char*) gdsl_list_search_by_position (la_liste, 4) );

  Ecrire_LCD(Ligne1,0x00) ;
  Ecrire_LCD(Ligne2,0x40) ;
  Ecrire_LCD(Ligne3,0x14) ;
  Ecrire_LCD(Ligne4,0x54) ;
}


// Ameliorer : comparaison int avec ulong !!

void Scroll2(bool Haut, int index_courant2,gdsl_list_t liste)
{
 gdsl_element_t el ;
 unsigned long index_max , index_courant;

 index_max =  gdsl_list_get_card (liste) ; 
 index_courant = index_courant2;


 if (Haut)
  {
    strcpy(Ligne1,Ligne2);
    strcpy(Ligne2,Ligne3);
    strcpy(Ligne3,Ligne4);

    if ( index_courant +3 <= index_max )
      el = gdsl_list_search_by_position (liste, index_courant + 3) ;
    else 
      el =gdsl_list_search_by_position(liste,(index_courant + 3 - index_max)) ;
    strcpy(Ligne4,el) ;
  }
else
  {
    strcpy(Ligne4,Ligne3);
    strcpy(Ligne3,Ligne2);
    strcpy(Ligne2,Ligne1);

    //    if( index_courant - 3 >= 1)
      el = gdsl_list_search_by_position (liste, index_courant) ;
      /*else 
          el =gdsl_list_search_by_position(liste,(index_max -(index_courant - 3)) ); 
      */
   strcpy(Ligne1,el) ;//index_courant
  }

  mvprintw(0,20,"index courant : %d - max : %d     ",index_courant,index_max);
  refresh();

  Clean_Lines();

  Ecrire_LCD(Ligne1,0x00) ;
  Ecrire_LCD(Ligne2,0x40) ;
  Ecrire_LCD(Ligne3,0x14) ;
  Ecrire_LCD(Ligne4,0x54) ;
}


int Check_Dir2(char *chemin)
{
  struct dirent **namelist;
  int n,result;

  n = scandir(chemin,&namelist,0,alphasort);
  result = n;
  if(n<0)
    perror("Check_dir2 : scandir");
  else
    while(n--)
      {
	//gdsl_list_insert_head(liste,buf); Erreur de Segm avec liste
	mvprintw(n,0,"%s",namelist[n]->d_name);
      }
      return(result - 2); 
}


void Clean_Lines()
{
  // Cleanup
 int longueur ; 
 char ligne_finale[21]="";

 longueur = strlen(Ligne1);
 while ( strlen(Ligne1) <20)
   strcat(Ligne1," ");
  
 longueur = strlen(Ligne2);
 while ( strlen(Ligne2) <19)
   strcat(Ligne2," ");

 longueur = strlen(Ligne3);
 while ( strlen(Ligne3) <19)
   strcat(Ligne3," ");

 longueur = strlen(Ligne4);
 while ( strlen(Ligne4) <19)
   strcat(Ligne4," ");

}

// A FINIR : AJOUTER LA GESTION DES ERREURS ET FICHIERS DEJA PRESENTS
// VOIR AVEC fopen en Glibc

int Copie(char * source, int type_dest)
{
  FILE *in,*out;
  char buf_orig[100]="", buf_dest[100]="", buf[100]="";
  int i=0;


  if ( type_dest == MUSIQUE)
  {
    strcpy (buf_orig,CHEMIN_ORIGINE_MUSIQUES);
    strcat(buf_orig,source);
    strcpy (buf_dest,CHEMIN_DESTINATION_MUSIQUES);
    strcat(buf_dest, source);
  }
  else if (type_dest == MESSAGE)
  {
    strcpy (buf_orig,CHEMIN_ORIGINE_MESSAGES);
    strcat(buf_orig,source);
    strcpy (buf_dest,CHEMIN_DESTINATION_MESSAGES);
    strcat(buf_dest, source);
  }

  /* open the input file */
  if ((in=fopen(buf_orig,"r"))==NULL)
    return(-1);
  if ((out=fopen(buf_dest,"wt"))==NULL)
    {
      fclose(in);
      return(-1);
    }
  
  /* copy the file contents */
  while (i=fread(buf,1,100,in))
                if (fwrite(buf,1,i,out)!=i)
		  break;
  
  /* now set up the return */
  i=(ferror(in)||ferror(out))?-1:0;
  
  /* close the files */
  fclose(in);
  fclose(out);
  return(i);
}


int Copie_CD_HD(int type_dest)
{
 DIR * dp             ;
 struct dirent *ep    ;
 int Nb_Fichiers=0    ;  
 char full_orig_path[100], full_dest_path[100]  ;
 if (type_dest == MUSIQUE)
   dp = opendir(CHEMIN_ORIGINE_MUSIQUES) ;
 else dp = opendir(CHEMIN_ORIGINE_MESSAGES) ;

 if (dp!= NULL)
   {
     while(ep = readdir(dp))
       {
	 Copie(ep->d_name,type_dest)  ;

	 mvprintw(23,0,"Copie de %s ",ep->d_name);
	 mvprintw(24,0,"vers %d (1: Mus, 2: Mes)",type_dest);
	 refresh()                              ;
	 ++Nb_Fichiers                          ;
       }
     (void) closedir(dp);
   }
 else printw("ne peut ouvrir");

 if(Nb_Fichiers >=2)
   return(Nb_Fichiers-2);
 else return 0;
}


unsigned int check_dir(char *chemin, bool Affiche)
{

  DIR * dp;
  struct dirent *ep;

 
 int Nb_Fichiers=0;
 dp = opendir(chemin);

 if (dp!= NULL)
   {
     while(ep = readdir(dp))
       {
	 //gdsl_list_insert_head(liste,ep->d_name);
	 //	 mvprintw(23,0,"%s\n",ep->d_name);
	 //Ecrire_LCD(ep->d_name,0x40);
	
	 Nb_Fichiers++;
	 
       }

     (void) closedir(dp);
   }
 else printw("ne peut ouvrir");

 /* A refaire : s'il reste 1 fichier -> -1 ? */
 if(Nb_Fichiers >=2)
   return(Nb_Fichiers-2);
 else return 0;
}

void print_menu(WINDOW *menu_win,int highlight)
{
  int x,y,i;

  x=2;
  y=2;
  box(menu_win,0,0);
  for(i=0;i<n_choices;++i)
    {
      if(highlight ==i+1)
      {
	wattron(menu_win,A_REVERSE);
	mvwprintw(menu_win,y,x,"%s",choices[i]);
	wattroff(menu_win,A_REVERSE);
      }
      else mvwprintw(menu_win,y,x,"%s",choices[i]);
      ++y;
    }
  wrefresh(menu_win);
}

int del_dir(char *repertoire)
{
  /* si d'autres process travaillent avec le fichier a supprimer, 
     unlink attend qu'ils le ferme pour le dtruire */

 DIR * dp             ;
 struct dirent *ep    ;
 int  retour,Nb_Fichiers       ; 
 char full_path[100]  ;

 dp = opendir(repertoire) ;

 if (dp!= NULL)
   {
     while(ep = readdir(dp))
       {
	 strcpy(full_path, repertoire)           ;
	 strcat(full_path,ep->d_name)            ;
	 retour = unlink(full_path)              ;
	 if(retour)
	    printw("Delete repertoire : Erreur pour %s",full_path)      ;
	 mvprintw(23,0,"Supprime %s ",full_path);
	 refresh()                               ;
	 ++Nb_Fichiers                           ;
       }
     (void) closedir(dp)                         ;
   }
 else printw("Delete repertoire : ne peut ouvrir")      ;

 if(Nb_Fichiers >=0)
   return(Nb_Fichiers - 2);
 else return 0;
}


void Init_LCD (void)
{
  char Init[3],i;
  Init[0] = 0x0D; /* Initialisation de l'affichage */
  Init[1] = 0x38; /* 2 lignes, communication sur 8 bits */
  Init[2] = 0x01; /* Efface l'cran */
  
  outb(inb(CONTROL) & 0xDF,CONTROL); /* On place le port parallle en sortie */
  RAZ_RS;
  
  for(i=0;i<=2;i++)
  {
    outb(Init[i],lpt_port); /* On place la donne sur le bus */
    SET_E;
    Tempo(20); /* Dlais de 20 ms */
    RAZ_E;
    Tempo(20);
  }
  SET_RS;
}

void Efface_LCD (void)
{
 RAZ_RS;
 outb(0x01,lpt_port); /* On place l'instruction d'effacement sur le bus */
 SET_E;
 Tempo(20);
 RAZ_E;
 Tempo(20);
 SET_RS;
}

void Ecrire_LCD (char *Chaine, char Position)
{
  int i,Taille;
  Taille=strlen(Chaine);
  RAZ_RS;
  outb(0x80+Position,lpt_port); /* Adresse d'criture */
  SET_E;
  Tempo(20);
  RAZ_E;
  Tempo(20);
  SET_RS;
  for(i=0;i<Taille;i++)
  {
   outb(Chaine[i],lpt_port); /* On place la donne sur le bus */
   SET_E;
     Tempo(2);
   RAZ_E;
    Tempo(2);
  }
}

void Menu_LCD(int index_menu)
{
  char ligne_finale[21]="";
 int longueur = strlen(choices[index_menu]);
 strcpy(ligne_finale,choices[index_menu]);
 while ( strlen(ligne_finale) <19)
   strcat(ligne_finale," "); 
 Ecrire_LCD(ligne_finale,0x00);

}

float Get_Disk_Stats(char * chemin)
{
 struct statfs stats             ;
 float div2k, pc_used            ;


 if(statfs(chemin, &stats) != 0)
 {
  fprintf(stderr, "error getting stats for %s\n",  chemin);
  exit(1);
 }

 div2k = stats.f_bsize/1024;
 
 /* printf( "total blocks: %ld (%ldk)\n",  stats.f_blocks,
	 stats.f_blocks*(long int)div2k );
 printf( "used blocks: %ld (%ldk)\n",  stats.f_blocks - stats.f_bfree,
	 (stats.f_blocks - stats.f_bfree)*(long int)div2k );
 printf( "available blocks: %ld (%ldk)\n",  stats.f_bavail,
	 stats.f_bavail*(long int)div2k );
 */
 pc_used = PERCENT_USED(stats) > 0 ? PERCENT_USED(stats):0 ;  

 /*
 printf( "percentage full: %.1f%%\n", pc_used);
 
 printf("\n");
 printf("stats = {\n"); 
 
 printf("  f_type: 0x%X\n", stats.f_type);
 printf("  f_bsize: %ld\n", stats.f_bsize);
 printf("  f_blocks: %ld\n", stats.f_blocks);
 printf("  f_bfree: %ld\n", stats.f_bfree);
 printf("  f_bavail: %ld\n", stats.f_bavail);
 printf("  f_files: %ld\n", stats.f_files);
 printf("  f_ffree: %ld\n", stats.f_ffree);
 printf("  f_fsid: %ld\n", stats.f_fsid);
 printf("  f_namelen: %ld\n", stats.f_namelen);
 */
 return (pc_used);
} 


/* Frequence_Message : combien de fois apparaitra un message :
          1 Message / Frequence_Message * .mp3                           */
/*
void Create_PlayList(int Frequence_Message)
{ 
  NODE     * Musiques_Liste, *Messages_Liste;
  FILEINFO * dir_musiques, *dir_messages;
  FILE *hand_fich;
  char *res="", *res2="" ;
  int Inc_Frequence = 0;


  Messages_Liste = load_dir_list (CHEMIN_DESTINATION_MESSAGES, "");
  if (! Messages_Liste)
    printf("Erreur Memoire : Creation liste Messages");
    

  // Cre le fichier de playlist en criture
  hand_fich = file_open("/home/workspace/playlist.mpl",'w');  
  
  Musiques_Liste = load_dir_list (CHEMIN_DESTINATION_MUSIQUES, "");
  if (Musiques_Liste)
    { 
     dir_messages  = Messages_Liste-> next; // init Liste chaine Messages

     for (dir_musiques  = Musiques_Liste-> next;
	dir_musiques != (FILEINFO *) Musiques_Liste;dir_musiques  = dir_musiques-> next)
	{ 
	  // Mettre en forme le chemin
	  res = formate_dir(&dir_musiques->dir);
	  if (!(file_write(hand_fich,res)))
	    printf("Erreur enregistrement Playliste");
	  ++Inc_Frequence;
	  if (Inc_Frequence == Frequence_Message)
	    {
	      dir_messages  = dir_messages-> next ;
	      res2 = formate_dir(&dir_messages->dir);
	      file_write(hand_fich,res2);
	      Inc_Frequence = 0;
	    }
	}
      free_dir_list (Musiques_Liste);
      free_dir_list (Messages_Liste);
    } 
  file_close(hand_fich);
} 

*/

void Tempo(unsigned long temps)  // en mS
{
  unsigned long index ;
  for(index =0; index<temps*20000;index++);
}

char *intoa(int i)
{
  char *pos = buf+sizeof(buf)-1;
  unsigned int u;
  int negative = 0;
  if(i<0)
    {
      negative= 1;
      u=((unsigned int)(-(1+i)))+1;
    }
  else u = i;
  *pos = 0;
do
  {
    *--pos ='0'+(u%10);
    u/=10;
  }while(u);
 if(negative)
   *--pos='-';

 return pos;
}

//Test GDSL


static void 
affiche_liste_chaines_fwd (gdsl_list_t l)
{
  int i = 0;
  //printf ("%s = ( ", gdsl_list_get_name (l));
  
  for (gdsl_list_cursor_move_to_head (l); i < gdsl_list_get_card (l); gdsl_list_cursor_move_forward (l))
    {
      //affiche_chaine (gdsl_list_cursor_get (l), NULL);
      mvprintw(i,0,gdsl_list_cursor_get (l));      
      refresh();
      i++;
    }
  //  printf (")\n");
}

static void 
affiche_liste_chaines_bwd (gdsl_list_t l)
{
  gdsl_element_t e;

  /*
  printf ("%s = ( ", gdsl_list_get_name (l));
  gdsl_list_map_backward (l, affiche_chaine, NULL);
  printf (")\n");
  */
  printf ("%s = ( ", gdsl_list_get_name (l));

  for (gdsl_list_cursor_move_to_tail (l); (e = gdsl_list_cursor_get (l)); gdsl_list_cursor_move_backward (l))
    affiche_chaine (e, NULL);
  printf (")\n");
}

static int 
affiche_chaine (gdsl_element_t chaine, void *user_infos)
{
 printf ("%s, ", (char *) chaine);
 return 1;
}

static void
affiche_element (gdsl_element_t chaine, FILE *file, void *user_data)
{
  fprintf (file, "%s", (char *) chaine);
}

static gdsl_element_t 
alloue_chaine (void *chaine)
{
#ifdef HAVE_MEM_DEBUG
  char *string = (char *) _gdsl_mem_alloc (1 + strlen ((char *) chaine));
#else
  char *string = (char *) malloc (1 + strlen ((char *) chaine));
#endif
  strcpy (string, (char *) chaine);
  return (gdsl_element_t) string;
}

static void 
detruis_chaine (gdsl_element_t chaine)
{
#ifdef HAVE_MEM_DEBUG
  _gdsl_mem_free (chaine);
#else
  free (chaine);
#endif
}

static int 
compare_chaines (gdsl_element_t chaine, void *value)
{
  return strcmp ((char *) chaine, (char *) value); 
}



//Fin de Test GDSL--------------------------------------------------
